| IGLib 1.4 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Properties

# IG::Script::ScriptAppBase Class Reference

Partial class definition containing tests of CSV utilities. Original class location: ....cs (locate it with "Go to definition" on class name). More...

Inheritance diagram for IG::Script::ScriptAppBase:
[legend]
Collaboration diagram for IG::Script::ScriptAppBase:
[legend]

List of all members.

## Public Member Functions
void | Script_AddCommands1 (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter. This is the part of adding commands in the partial class.
| ScriptAppBase ()
override void | Script_AddCommands (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds commands to the internal interpreter.
virtual string | RunFileByScript (string filePath)
| Runs all commands that are written in a file. Each line of a file is interpreted as a single command, consisting of command name followed by arguments.
string | AppMyTest (string[] arguments)
| Test action.
virtual string | AppCustomApp (string[] arguments)
| Custom application.
virtual string | AppNumerics (string[] arguments)
| Runs one of the numerics - related embedded applications.
virtual string | AppFile (string[] arguments)
| Runs one of the file system - related embedded applications.
virtual string | AppSystem (string[] arguments)
| Runs one of the file system - related embedded applications.
virtual string | AppProcess (string[] arguments)
| Runs one of the process - related embedded applications.
virtual string | AppDataStructures (string[] arguments)
| Runs one of the data structures demo - related embedded applications.
## Public Attributes
const string | DataStructuresTestCsvApp = "TestCsv"
const string | DataStructuresTestCsvWriteDefinitionAndData = "CsvWriteDefinitionAndData"
const string | DataStructuresTestCsvReadDefinitionAndData = "CsvReadDefinitionAndData"
const string | ConstMyTest = "MyTest"
| Name of the command that performs my custom test.
const string | ConstHelpMyTest = "Custom test function."
const string | ConstCustomApp = "CustomApp"
| Name of the command for custom test.
const string | ConstHelpCustomApp = "Custom aplication."
const string | ConstSystem = "System"
| Name of the command for the system-related embedded applications.
const string | ConstHelpSystem = "Various system-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstNumerics = "Numerics"
| Name of the command for the numerics-related embedded applications.
const string | ConstHelpNumerics = "Various numerics-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstFile = "File"
| Name of the command for the file system-related embedded applications.
const string | ConstHelpFile = "Various file system-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstProcess = "Process"
| Name of the command for the process-related embedded applications.
const string | ConstHelpProcess = "Various process-related embedded applications. Run with ? argument to see which applications are available."
const string | ConstDataStructures = "DataStructures"
| Name of the command for the data structures-related embedded applications.
const string | ConstHelpDataStructures
const string | ConstRunFile = "RunFileByScript"
| Name of the command that runs (interprets) the specified command file by the script's interpreter.
const string | ConstHelpRunFile
const string | NumericsScriptScalarFunction = "ScriptScalarFunction"
const string | FileLogEvents = "LogEvents"
const string | FileWaitCreation = "WaitCreation"
const string | SystemRuntimeVersion = "RuntimeVersion"
const string | SystemComputerName = "ComputerName"
const string | SystemDomainName = "DomainName"
const string | SystemIpAddress = "IpAddress"
const string | SystemUserName = "UserName"
const string | SystemSystemInfo = "Info"
const string | SystemMACAddress = "MACAddress"
const string | ProcessListProcesses = "ListProcesses"
const string | ProcessListApplications = "ListApplications"
const string | ProcessListApplicationsByWindow = "ListApplicationsByWindow"
const string | ProcessKillProcesses = "KillProcesses"
const string | ProcessKillApplications = "KillApplications"
const string | ProcessKillApplicationsByWindow = "KillApplicationsByWindow"
## Protected Member Functions
virtual void | InitAppDataStructuresPartial ()
| Initializes commands for form demo related utilities (embedded applications).
virtual string | DataStructuresFunctionTestCsvApp (string appName, string[] args)
| Executes embedded application - demo application for demonstration of work with CSVs.
virtual string | DataStructuresFunctionTestCsvWriteDefinitionAndData (string appName, string[] args)
| Executes embedded application - test of writing sampled data definition & data in CSV format.
virtual string | DataStructuresFunctionTestCsvReadDefinitionAndData (string appName, string[] args)
| Executes embedded application - test of writing sampled data definition & data in CSV format.
override void | InitializeThis (string[] arguments)
| Initializes the current object.
override string | RunThis (string[] arguments)
| Runs action of the current object.
void | Script_AddRunFileByScriptCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Adds the Run comand to the script's interpreter and performs the necessary additional tasks. The run command runs line by line the specified command file by the script's interpreter.
void | Script_RemoveRunFileByScriptCommand (ICommandLineApplicationInterpreter interpreter, SortedList< string, string > helpStrings)
| Removes the Run comand from the script's interpreter and performs the necessary accompanying tasks.
virtual string | AppRunFileByScript (string[] args)
| Execution method that Runs the specified command file by the script's interpreter.
void | AddNumericsCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new numerics - related embedded application's command (added as sub-command of the base command named ConstNumerics).
virtual string | NumericsFunctionScriptScalarFuncitons (string surfaceName, string[] args)
| Executes embedded application - testing of definition of scalar function objects through expressions.
virtual void | InitAppNumerics ()
| Initializes commands for numerics related utilities (embedded applications).
virtual string | RunAppNumerics (string[] args)
| Runs a numerics related utility (embedded application) according to arguments.
void | AddFileCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new file system - related embedded application's command (added as sub-command of the base command named ConstFile).
virtual string | FileFunctionLogEvents (string surfaceName, string[] args)
| Executes embedded application - writing to the console information about file events for the specified file or directory.
virtual string | FileFunctionWaitCreation (string surfaceName, string[] args)
| Executes embedded application - waiting for creation of the specified file. Application blocks until the specified file is created.The first argument must be path to the file whose creation is waited for.Optional second argument (boolean) specifies whether function automatically unblocks if the file already exists.
virtual void | InitAppFile ()
| Initializes commands for file system related utilities (embedded applications).
virtual string | RunAppFile (string[] args)
| Runs a file system related utility (embedded application) according to arguments.
void | AddSystemCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new system - related embedded application's command (added as sub-command of the base command named ConstSystem).
virtual string | SystemFunctionRuntimeVersion (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning version of the runtime that application runs on.
virtual string | SystemFunctionComputerName (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning the current computer name.
virtual string | SystemFunctionDomainName (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning the current domain name.
virtual string | SystemFunctionIpAddress (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning the current IP address.
virtual string | SystemFunctionUserName (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning the current user name.
virtual string | SystemFunctionSystemInfo (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning the system info.
virtual string | SystemFunctionMACAddress (string surfaceName, string[] args)
| Executes embedded application - writing to the console and returning the current domain name.
virtual void | InitAppSystem ()
| Initializes commands for file system related utilities (embedded applications).
virtual string | RunAppSystem (string[] args)
| Runs a file system related utility (embedded application) according to arguments.
void | AddProcessCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new process - related embedded application's command (added as sub-command of the base command named ConstProcess).
virtual string | ProcessFunctionListProcesses (string surfaceName, string[] args)
| Embedded application - lists all processes that satisfy the specified conditions.
virtual string | ProcessFunctionListApplications (string surfaceName, string[] args)
| Embedded application. Lists all running applications sarisfyin specified conditions.
virtual string | ProcessFunctionListApplicationsByWindow (string surfaceName, string[] args)
| Embedded application. Lists all running applications sarisfyin specified conditions.
virtual string | ProcessFunctionKillProcesses (string surfaceName, string[] args)
| Embedded application - kills all processes that satisfy the specified conditions.
virtual string | ProcessFunctionKillApplications (string surfaceName, string[] args)
| Embedded application. Kills all running applications sarisfyin specified conditions.
virtual string | ProcessFunctionKillApplicationsByWindow (string surfaceName, string[] args)
| Embedded application. Kills all running applications sarisfyin specified conditions.
virtual void | InitAppProcess ()
| Initializes commands for process - related utilities (embedded applications).
virtual string | RunAppProcess (string[] args)
| Runs a process - related utility (embedded application) according to arguments.
void | AddDataStructuresCommand (string appName, CommandMethod appMethod, string appHelp)
| Adds a new data structure- related embedded demo application's command (added as a sub-command of the base command named ConstDataStructures).
virtual void | InitAppDataStructures ()
| Initializes commands for form demo related utilities (embedded applications).
virtual string | RunAppDataStructures (string[] args)
| Runs a data structures demo - related utility (embedded application) according to arguments.
## Protected Attributes
const string | DataStructuresHelpTestCsvApp = " : Runs the CSV simple demo application."
const string | DataStructuresHelpTestCsvWriteDefinitionAndData
const string | DataStructuresHelpTestCsvReadDefinitionAndData
bool | _isAddRunFileByScriptCommand = true
List< string > | AppNumericsNames = new List<string>()
| List of installed numerics command names.
List< string > | AppNumericsHelpStrings = new List<string>()
| List of help strings corresponding to installed numerics-related commands.
List< CommandMethod > | AppNumericsMethods = new List<CommandMethod>()
| List of methods used to perform numerics-related commmands.
const string | NumericsHelpScriptScalarFunction = " : Definition of scalar functions by expressions."
bool | _appNumericsCommandsInitialized = false
List< string > | AppFileNames = new List<string>()
| List of installed file command names.
List< string > | AppFileHelpStrings = new List<string>()
| List of help strings corresponding to installed file commands.
List< CommandMethod > | AppFileMethods = new List<CommandMethod>()
| List of methods used to perform file commmands.
const string | FileHelpLogEvents = " FileOrDirectory MaxEvents : Logs file events for the specified file or directory."
const string | FileHelpWaitCreation = " FilePath <ReturnIfExists> : Waits until file is created."
bool | _appFileCommandsInitialized = false
List< string > | AppSystemNames = new List<string>()
| List of installed system related command names.
List< string > | AppSystemHelpStrings = new List<string>()
| List of help strings corresponding to installed system related commands.
List< CommandMethod > | AppSystemMethods = new List<CommandMethod>()
| List of methods used to perform system related commmands.
const string | SystemHelpRuntimeVersion = " : Prints version of the runtime environment that application runs on."
const string | SystemHelpComputerName = " : Prints and returns the current computer name."
const string | SystemHelpDomainName = " : Prints and returns the current domain name."
const string | SystemHelpIpAddress = " : Prints and returns IP address of the current computer."
const string | SystemHelpUserName = " : Prints and returns the current user name."
const string | SystemHelpSystemInfo = " : Prints and returns basic system info."
const string | SystemHelpMACAddress = " : Prints and returns the current domain name."
bool | _appSystemCommandsInitialized = false
List< string > | AppProcessNames = new List<string>()
| List of installed process-related command names.
List< string > | AppProcessHelpStrings = new List<string>()
| List of help strings corresponding to installed process commands.
List< CommandMethod > | AppProcessMethods = new List<CommandMethod>()
| List of methods used to perform process-related commmands.
const string | ProcessHelpListProcesses
const string | ProcessHelpListApplications
const string | ProcessHelpListApplicationsByWindow
const string | ProcessHelpKillProcesses
const string | ProcessHelpKillApplications
const string | ProcessHelpKillApplicationsByWindow
bool | _appProcessCommandsInitialized = false
List< string > | AppDataStructuresNames = new List<string>()
| List of installed data structure - related demo command names.
List< string > | AppDataStructuresHelpStrings = new List<string>()
| List of help strings corresponding to the installed data structure - related demo commands.
List< CommandMethod > | AppDataStructuresMethods = new List<CommandMethod>()
| List of methods used to perform data structure - related demo commmands.
bool | _appDataStructuresCommandsInitialized = false
## Properties
virtual bool | IsAddRunFileByScriptCommand`[get, set]`
| Whether or not the Run command is installed on the script's interpreter.

## Detailed Description

Partial class definition containing tests of CSV utilities.

Original class location: ....cs (locate it with "Go to definition" on class name).

Base cls. for application scripts.

The cls.es derived from this cls. are usually used as internal scripts and provide a set of embedded utiliy applications within an application that is based on an command-line interpreter.

Applications will typically extend this cls. by their own specific cls. that is used in its place for providing various embedded utility applications. The base library itself provides the AppBase cls. derived from this cls., which is used because its shorter name. See that cls. for an example how to prepare a derived cls. that will provide as set of embedded applications.

In applications that have the command-line interpreter, embedded applications from this cls. can typically be run in the following way:

AppName Internal IG.Script.AppBase CommandName arg1 arg2 ...

where AppName is the application name, IG.Script.AppBase is the full name of the script cls. that contains embedded applications, CommandName is name of the command thar launches embedded application, and arg1, arg2, etc. are command arguments for the embedded application. In some applications, cls. name may be different and may be a name of a derived cls. that provides extended functionality or just provides a more suitable name of the script.

$A Igor xx Sep12;

## Constructor & Destructor Documentation

IG::Script::ScriptAppBase::ScriptAppBase | ( |  | ) | `[inline]`

## Member Function Documentation

void IG::Script::ScriptAppBase::Script_AddCommands1 | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  | `[inline]`

Adds commands to the internal interpreter. This is the part of adding commands in the partial class.

Parameters:

  interpreter | Interpreter where commands are executed.
  helpStrings | List containg help strings.

virtual void IG::Script::ScriptAppBase::InitAppDataStructuresPartial | ( |  | ) | `[inline, protected, virtual]`

Initializes commands for form demo related utilities (embedded applications).

virtual string IG::Script::ScriptAppBase::DataStructuresFunctionTestCsvApp | ( | string | appName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - demo application for demonstration of work with CSVs.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::DataStructuresFunctionTestCsvWriteDefinitionAndData | ( | string | appName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - test of writing sampled data definition & data in CSV format.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

1st argument: path to the data definition file in JSON.

2nd argument: path to the data file in JSON.

3rd argument: path to the output file where data in CSV is written.

4th argument: whether key and data are in the same row.

5th argument: indentation - number of empty cells before data begins.

All arguments are optional. Relative paths are considered relative to the .../workspaceprojects/00tests/data/sampleddata directory if the workspaceprojects directory can be determined (define the WORKSPACE variable for this).

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::DataStructuresFunctionTestCsvReadDefinitionAndData | ( | string | appName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - test of writing sampled data definition & data in CSV format.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

1st argument: path to CSV file that contains definitions and data to be read.

2nd argument: path to the file where the read-in definitions and data will be written (in CSV).

3rd argument: if true then key and data are in the same row when writing the data.

4th argument: indentation - number of empty cells before data begins when writing the data.

All arguments are optional. Relative paths are considered relative to the .../workspaceprojects/00tests/data/sampleddata directory if the workspaceprojects directory can be determined (define the WORKSPACE variable for this).

Returns:
  Number of arguments passed.

override void IG::Script::ScriptAppBase::InitializeThis | ( | string[] | arguments | ) | `[inline, protected, virtual]`

Initializes the current object.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

override string IG::Script::ScriptAppBase::RunThis | ( | string[] | arguments | ) | `[inline, protected, virtual]`

Runs action of the current object.

Parameters:

  arguments | Command-line arguments of the action.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

override void IG::Script::ScriptAppBase::Script_AddCommands | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  | `[inline, virtual]`

Adds commands to the internal interpreter.

Parameters:

  interpreter | Interpreter where commands are executed.
  helpStrings | List containg help strings.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

Reimplemented in IG::Script::AppBase, and IG::Script::AppExtBase.

void IG::Script::ScriptAppBase::Script_AddRunFileByScriptCommand | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  | `[inline, protected]`

Adds the Run comand to the script's interpreter and performs the necessary additional tasks. The run command runs line by line the specified command file by the script's interpreter.

void IG::Script::ScriptAppBase::Script_RemoveRunFileByScriptCommand | ( | ICommandLineApplicationInterpreter | interpreter,
|  | SortedList< string, string > | helpStrings
| ) |  | `[inline, protected]`

Removes the Run comand from the script's interpreter and performs the necessary accompanying tasks.

virtual string IG::Script::ScriptAppBase::AppRunFileByScript | ( | string[] | args | ) | `[inline, protected, virtual]`

Execution method that Runs the specified command file by the script's interpreter.

Parameters:

  args | Command arguments. Command file path must be the only argument.

virtual string IG::Script::ScriptAppBase::RunFileByScript | ( | string | filePath | ) | `[inline, virtual]`

Runs all commands that are written in a file. Each line of a file is interpreted as a single command, consisting of command name followed by arguments.

Parameters:

  filePath | Path to the file containing commands.

Returns:
  Return value of the last command.

string IG::Script::ScriptAppBase::AppMyTest | ( | string[] | arguments | ) | `[inline]`

Test action.

Parameters:

  arguments | Array of command-line arguments.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

virtual string IG::Script::ScriptAppBase::AppCustomApp | ( | string[] | arguments | ) | `[inline, virtual]`

Custom application.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

void IG::Script::ScriptAppBase::AddNumericsCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  | `[inline, protected]`

Adds a new numerics - related embedded application's command (added as sub-command of the base command named ConstNumerics).

Parameters:

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG::Script::ScriptAppBase::NumericsFunctionScriptScalarFuncitons | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - testing of definition of scalar function objects through expressions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual void IG::Script::ScriptAppBase::InitAppNumerics | ( |  | ) | `[inline, protected, virtual]`

Initializes commands for numerics related utilities (embedded applications).

virtual string IG::Script::ScriptAppBase::RunAppNumerics | ( | string[] | args | ) | `[inline, protected, virtual]`

Runs a numerics related utility (embedded application) according to arguments.

Parameters:

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG::Script::ScriptAppBase::AppNumerics | ( | string[] | arguments | ) | `[inline, virtual]`

Runs one of the numerics - related embedded applications.

Parameters:

  arguments | Array containing the base command name, application command name and arguments.

void IG::Script::ScriptAppBase::AddFileCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  | `[inline, protected]`

Adds a new file system - related embedded application's command (added as sub-command of the base command named ConstFile).

Parameters:

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG::Script::ScriptAppBase::FileFunctionLogEvents | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console information about file events for the specified file or directory.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::FileFunctionWaitCreation | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - waiting for creation of the specified file. Application blocks until the specified file is created.The first argument must be path to the file whose creation is waited for.Optional second argument (boolean) specifies whether function automatically unblocks if the file already exists.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual void IG::Script::ScriptAppBase::InitAppFile | ( |  | ) | `[inline, protected, virtual]`

Initializes commands for file system related utilities (embedded applications).

Reimplemented in IG::Script::AppBase.

virtual string IG::Script::ScriptAppBase::RunAppFile | ( | string[] | args | ) | `[inline, protected, virtual]`

Runs a file system related utility (embedded application) according to arguments.

Parameters:

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG::Script::ScriptAppBase::AppFile | ( | string[] | arguments | ) | `[inline, virtual]`

Runs one of the file system - related embedded applications.

Parameters:

  arguments | Array containing the base command name, application command name and arguments.

void IG::Script::ScriptAppBase::AddSystemCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  | `[inline, protected]`

Adds a new system - related embedded application's command (added as sub-command of the base command named ConstSystem).

Parameters:

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG::Script::ScriptAppBase::SystemFunctionRuntimeVersion | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning version of the runtime that application runs on.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::SystemFunctionComputerName | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning the current computer name.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::SystemFunctionDomainName | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning the current domain name.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::SystemFunctionIpAddress | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning the current IP address.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::SystemFunctionUserName | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning the current user name.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::SystemFunctionSystemInfo | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning the system info.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual string IG::Script::ScriptAppBase::SystemFunctionMACAddress | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Executes embedded application - writing to the console and returning the current domain name.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of arguments passed.

virtual void IG::Script::ScriptAppBase::InitAppSystem | ( |  | ) | `[inline, protected, virtual]`

Initializes commands for file system related utilities (embedded applications).

virtual string IG::Script::ScriptAppBase::RunAppSystem | ( | string[] | args | ) | `[inline, protected, virtual]`

Runs a file system related utility (embedded application) according to arguments.

Parameters:

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG::Script::ScriptAppBase::AppSystem | ( | string[] | arguments | ) | `[inline, virtual]`

Runs one of the file system - related embedded applications.

Parameters:

  arguments | Array containing the base command name, application command name and arguments.

void IG::Script::ScriptAppBase::AddProcessCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  | `[inline, protected]`

Adds a new process - related embedded application's command (added as sub-command of the base command named ConstProcess).

Parameters:

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual string IG::Script::ScriptAppBase::ProcessFunctionListProcesses | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Embedded application - lists all processes that satisfy the specified conditions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of processes.

virtual string IG::Script::ScriptAppBase::ProcessFunctionListApplications | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Embedded application. Lists all running applications sarisfyin specified conditions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of processes.

virtual string IG::Script::ScriptAppBase::ProcessFunctionListApplicationsByWindow | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Embedded application. Lists all running applications sarisfyin specified conditions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of processes.

virtual string IG::Script::ScriptAppBase::ProcessFunctionKillProcesses | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Embedded application - kills all processes that satisfy the specified conditions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of processes.

virtual string IG::Script::ScriptAppBase::ProcessFunctionKillApplications | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Embedded application. Kills all running applications sarisfyin specified conditions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of processes.

virtual string IG::Script::ScriptAppBase::ProcessFunctionKillApplicationsByWindow | ( | string | surfaceName,
|  | string[] | args
| ) |  | `[inline, protected, virtual]`

Embedded application. Kills all running applications sarisfyin specified conditions.

Parameters:

  appName | Name of the embedded application.
  args | Arguments fo the embedded application's command.

Returns:
  Number of processes.

virtual void IG::Script::ScriptAppBase::InitAppProcess | ( |  | ) | `[inline, protected, virtual]`

Initializes commands for process - related utilities (embedded applications).

virtual string IG::Script::ScriptAppBase::RunAppProcess | ( | string[] | args | ) | `[inline, protected, virtual]`

Runs a process - related utility (embedded application) according to arguments.

Parameters:

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and teh rest arguments are arguments that are used by the embedded application.

virtual string IG::Script::ScriptAppBase::AppProcess | ( | string[] | arguments | ) | `[inline, virtual]`

Runs one of the process - related embedded applications.

Parameters:

  arguments | Array containing the base command name, application command name and arguments.

void IG::Script::ScriptAppBase::AddDataStructuresCommand | ( | string | appName,
|  | CommandMethod | appMethod,
|  | string | appHelp
| ) |  | `[inline, protected]`

Adds a new data structure- related embedded demo application's command (added as a sub-command of the base command named ConstDataStructures).

Parameters:

  appName | Application name.
  appMethod | Method used to perform the application.
  appHelp | Eventual help string for the application.

virtual void IG::Script::ScriptAppBase::InitAppDataStructures | ( |  | ) | `[inline, protected, virtual]`

Initializes commands for form demo related utilities (embedded applications).

virtual string IG::Script::ScriptAppBase::RunAppDataStructures | ( | string[] | args | ) | `[inline, protected, virtual]`

Runs a data structures demo - related utility (embedded application) according to arguments.

Parameters:

  args | Arguments. 0-th argument is the base command name, 1st argument is the embedded application name, and the rest are arguments that are used by the embedded application.

virtual string IG::Script::ScriptAppBase::AppDataStructures | ( | string[] | arguments | ) | `[inline, virtual]`

Runs one of the data structures demo - related embedded applications.

Parameters:

  arguments | Array containing the base command name, application command name and arguments.

## Member Data Documentation

const string IG::Script::ScriptAppBase::DataStructuresTestCsvApp = "TestCsv"

const string IG::Script::ScriptAppBase::DataStructuresHelpTestCsvApp = " : Runs the CSV simple demo application."`[protected]`

const string IG::Script::ScriptAppBase::DataStructuresTestCsvWriteDefinitionAndData = "CsvWriteDefinitionAndData"

const string IG::Script::ScriptAppBase::DataStructuresHelpTestCsvWriteDefinitionAndData`[protected]`

Initial value:

     DataStructuresTestCsvWriteDefinitionAndData +
    @" <defFile> <dataFile> <outFile> <sameRow> <indentation> ... : Tests writing of sampled data definition and data itself to CSV.
      defFile: path to JSON file that contains definitions of input and output data elements
      dataFile: JSON file that contains the data
      outFile: path to the file where data in CSV is written
      sameRow: if true then key and data are in the same row
      indentation: number of empty cells before data begins
        Relative paths are relative to the .../workspaceprojects/00tests/data/sampleddata directory
        when the workspaceprojects directory is defined (define its path with  the WORKSPACE
        system variable!)."

const string IG::Script::ScriptAppBase::DataStructuresTestCsvReadDefinitionAndData = "CsvReadDefinitionAndData"

const string IG::Script::ScriptAppBase::DataStructuresHelpTestCsvReadDefinitionAndData`[protected]`

Initial value:

     DataStructuresTestCsvReadDefinitionAndData +
    @" <inputFile> <outputFile> <sameRow> <indentation> ... : Tests reading of sampled data definition and data itself from CSV.
      inputFile: path to CSV file that contains definitions and data to be read (default: neuraldefinitionanddata.csv)
      outputFile: path to the file where the read-in definitions and data will be written in CSV (default: testdata/ReadAndWritten.csv)
      sameRow: if true then key and data are in the same row when writing the data
      indentation: number of empty cells before data begins when writing the data
        Relative paths are relative to the .../workspaceprojects/00tests/data/sampleddata directory
        when the workspaceprojects directory is defined (define its path with  the WORKSPACE
        system variable!)."

const string IG::Script::ScriptAppBase::ConstMyTest = "MyTest"

Name of the command that performs my custom test.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

const string IG::Script::ScriptAppBase::ConstHelpMyTest = "Custom test function."

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

const string IG::Script::ScriptAppBase::ConstCustomApp = "CustomApp"

Name of the command for custom test.

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

const string IG::Script::ScriptAppBase::ConstHelpCustomApp = "Custom aplication."

Reimplemented from IG::Script::LoadableScriptSpecialFunctionBase.

const string IG::Script::ScriptAppBase::ConstSystem = "System"

Name of the command for the system-related embedded applications.

const string IG::Script::ScriptAppBase::ConstHelpSystem = "Various system-related embedded applications. Run with ? argument to see which applications are available."

const string IG::Script::ScriptAppBase::ConstNumerics = "Numerics"

Name of the command for the numerics-related embedded applications.

const string IG::Script::ScriptAppBase::ConstHelpNumerics = "Various numerics-related embedded applications. Run with ? argument to see which applications are available."

const string IG::Script::ScriptAppBase::ConstFile = "File"

Name of the command for the file system-related embedded applications.

const string IG::Script::ScriptAppBase::ConstHelpFile = "Various file system-related embedded applications. Run with ? argument to see which applications are available."

const string IG::Script::ScriptAppBase::ConstProcess = "Process"

Name of the command for the process-related embedded applications.

const string IG::Script::ScriptAppBase::ConstHelpProcess = "Various process-related embedded applications. Run with ? argument to see which applications are available."

const string IG::Script::ScriptAppBase::ConstDataStructures = "DataStructures"

Name of the command for the data structures-related embedded applications.

const string IG::Script::ScriptAppBase::ConstHelpDataStructures

Initial value:

    @"Various data structures-related embedded demo applications.
      Run with the '?' argument to see which applications are available."

const string IG::Script::ScriptAppBase::ConstRunFile = "RunFileByScript"

Name of the command that runs (interprets) the specified command file by the script's interpreter.

const string IG::Script::ScriptAppBase::ConstHelpRunFile

Initial value:

    ConstRunFile + @" commandFile : Runs (interprets) the specified file by the script's interpreter.
      commandFile: path to the command file that is interpreted (usual extension: '.cmd')."

bool IG::Script::ScriptAppBase::_isAddRunFileByScriptCommand = true`[protected]`

List<string> IG::Script::ScriptAppBase::AppNumericsNames = new List<string>()`[protected]`

List of installed numerics command names.

List<string> IG::Script::ScriptAppBase::AppNumericsHelpStrings = new List<string>()`[protected]`

List of help strings corresponding to installed numerics-related commands.

List<CommandMethod> IG::Script::ScriptAppBase::AppNumericsMethods = new List<CommandMethod>()`[protected]`

List of methods used to perform numerics-related commmands.

const string IG::Script::ScriptAppBase::NumericsScriptScalarFunction = "ScriptScalarFunction"

const string IG::Script::ScriptAppBase::NumericsHelpScriptScalarFunction = " : Definition of scalar functions by expressions."`[protected]`

bool IG::Script::ScriptAppBase::_appNumericsCommandsInitialized = false`[protected]`

List<string> IG::Script::ScriptAppBase::AppFileNames = new List<string>()`[protected]`

List of installed file command names.

List<string> IG::Script::ScriptAppBase::AppFileHelpStrings = new List<string>()`[protected]`

List of help strings corresponding to installed file commands.

List<CommandMethod> IG::Script::ScriptAppBase::AppFileMethods = new List<CommandMethod>()`[protected]`

List of methods used to perform file commmands.

const string IG::Script::ScriptAppBase::FileLogEvents = "LogEvents"

const string IG::Script::ScriptAppBase::FileHelpLogEvents = " FileOrDirectory MaxEvents : Logs file events for the specified file or directory."`[protected]`

const string IG::Script::ScriptAppBase::FileWaitCreation = "WaitCreation"

const string IG::Script::ScriptAppBase::FileHelpWaitCreation = " FilePath <ReturnIfExists> : Waits until file is created."`[protected]`

bool IG::Script::ScriptAppBase::_appFileCommandsInitialized = false`[protected]`

List<string> IG::Script::ScriptAppBase::AppSystemNames = new List<string>()`[protected]`

List of installed system related command names.

List<string> IG::Script::ScriptAppBase::AppSystemHelpStrings = new List<string>()`[protected]`

List of help strings corresponding to installed system related commands.

List<CommandMethod> IG::Script::ScriptAppBase::AppSystemMethods = new List<CommandMethod>()`[protected]`

List of methods used to perform system related commmands.

const string IG::Script::ScriptAppBase::SystemRuntimeVersion = "RuntimeVersion"

const string IG::Script::ScriptAppBase::SystemHelpRuntimeVersion = " : Prints version of the runtime environment that application runs on."`[protected]`

const string IG::Script::ScriptAppBase::SystemComputerName = "ComputerName"

const string IG::Script::ScriptAppBase::SystemHelpComputerName = " : Prints and returns the current computer name."`[protected]`

const string IG::Script::ScriptAppBase::SystemDomainName = "DomainName"

const string IG::Script::ScriptAppBase::SystemHelpDomainName = " : Prints and returns the current domain name."`[protected]`

const string IG::Script::ScriptAppBase::SystemIpAddress = "IpAddress"

const string IG::Script::ScriptAppBase::SystemHelpIpAddress = " : Prints and returns IP address of the current computer."`[protected]`

const string IG::Script::ScriptAppBase::SystemUserName = "UserName"

const string IG::Script::ScriptAppBase::SystemHelpUserName = " : Prints and returns the current user name."`[protected]`

const string IG::Script::ScriptAppBase::SystemSystemInfo = "Info"

const string IG::Script::ScriptAppBase::SystemHelpSystemInfo = " : Prints and returns basic system info."`[protected]`

const string IG::Script::ScriptAppBase::SystemMACAddress = "MACAddress"

const string IG::Script::ScriptAppBase::SystemHelpMACAddress = " : Prints and returns the current domain name."`[protected]`

bool IG::Script::ScriptAppBase::_appSystemCommandsInitialized = false`[protected]`

List<string> IG::Script::ScriptAppBase::AppProcessNames = new List<string>()`[protected]`

List of installed process-related command names.

List<string> IG::Script::ScriptAppBase::AppProcessHelpStrings = new List<string>()`[protected]`

List of help strings corresponding to installed process commands.

List<CommandMethod> IG::Script::ScriptAppBase::AppProcessMethods = new List<CommandMethod>()`[protected]`

List of methods used to perform process-related commmands.

const string IG::Script::ScriptAppBase::ProcessListProcesses = "ListProcesses"

const string IG::Script::ScriptAppBase::ProcessHelpListProcesses`[protected]`

Initial value:

     ProcessListProcesses + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
        Lists running processes with specified names.
        ProcessName: process name. If not specified then all running processes are listed.
        CaseSensitive: whether process name is case sensitive, default is false.
        FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG::Script::ScriptAppBase::ProcessListApplications = "ListApplications"

const string IG::Script::ScriptAppBase::ProcessHelpListApplications`[protected]`

Initial value:

     ProcessListApplications + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
        Lists running applications (processes having main window with title) with specified process names.
        ProcessName: process name. If not specified then all running applications are listed.
        CaseSensitive: whether process name is case sensitive, default is false.
        FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG::Script::ScriptAppBase::ProcessListApplicationsByWindow = "ListApplicationsByWindow"

const string IG::Script::ScriptAppBase::ProcessHelpListApplicationsByWindow`[protected]`

Initial value:

     ProcessListApplicationsByWindow + @" <WindowTitle> <CaseSensitive> <FullName> <printDetails> :
        Lists running applications with specified names of main window title.
        WindowTitle: main window title of the application. If not specified then all running applications are listed.
        CaseSensitive: whether window title is case sensitive, default is false.
        FullName: whether full name must be specified (otherwise substring is enough), default is false."

const string IG::Script::ScriptAppBase::ProcessKillProcesses = "KillProcesses"

const string IG::Script::ScriptAppBase::ProcessHelpKillProcesses`[protected]`

Initial value:

     ProcessKillProcesses + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
        Kills running processes with specified names.
        ProcessName: process name. If not specified then all running processes are killed.
        CaseSensitive: whether process name is case sensitive, default is false.
        FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG::Script::ScriptAppBase::ProcessKillApplications = "KillApplications"

const string IG::Script::ScriptAppBase::ProcessHelpKillApplications`[protected]`

Initial value:

     ProcessKillApplications + @" <ProcessName> <CaseSensitive> <FullName> <printDetails> :
        Kills running applications (processes having main window with title) with specified process names.
        ProcessName: process name. If not specified then all running applications are killed.
        CaseSensitive: whether process name is case sensitive, default is false.
        FullName: whether full name must be specified (otherwise substring is enough), default is true."

const string IG::Script::ScriptAppBase::ProcessKillApplicationsByWindow = "KillApplicationsByWindow"

const string IG::Script::ScriptAppBase::ProcessHelpKillApplicationsByWindow`[protected]`

Initial value:

     ProcessKillApplicationsByWindow + @" <WindowTitle> <CaseSensitive> <FullName> <printDetails> :
        Kills running applications with specified names of main window title.
        WindowTitle: main window title of the application. If not specified then all running applications are killed.
        CaseSensitive: whether window title is case sensitive, default is false.
        FullName: whether full name must be specified (otherwise substring is enough), default is false."

bool IG::Script::ScriptAppBase::_appProcessCommandsInitialized = false`[protected]`

List<string> IG::Script::ScriptAppBase::AppDataStructuresNames = new List<string>()`[protected]`

List of installed data structure - related demo command names.

List<string> IG::Script::ScriptAppBase::AppDataStructuresHelpStrings = new List<string>()`[protected]`

List of help strings corresponding to the installed data structure - related demo commands.

List<CommandMethod> IG::Script::ScriptAppBase::AppDataStructuresMethods = new List<CommandMethod>()`[protected]`

List of methods used to perform data structure - related demo commmands.

bool IG::Script::ScriptAppBase::_appDataStructuresCommandsInitialized = false`[protected]`

## Property Documentation

virtual bool IG::Script::ScriptAppBase::IsAddRunFileByScriptCommand`[get, set]`

Whether or not the Run command is installed on the script's interpreter.

The documentation for this class was generated from the following files:

- ScriptAppBase1.cs
- ScriptAppBase.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events